package com.contextspace.objectdb_example.model.holder;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

import com.contextspace.objectdb_example.model.AttributeName;
import com.contextspace.objectdb_example.model.IDHolder;

@Entity
public class Holder extends IDHolder implements IHolder {
    
    private AttributeName name = null;
    private List<AttributeName> listOfNames = new ArrayList<AttributeName>();
    private Holder holder = null;
    
    /**
     * Default Constructor
     */
    public Holder() {
        
    }
    
    /**
     * @return the name
     */
    @OneToOne(cascade=CascadeType.ALL, fetch = FetchType.EAGER)
    public AttributeName getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(AttributeName name) {
        this.name = name;
    }

    /**
     * @return the holder
     */
    @OneToOne(cascade=CascadeType.ALL, fetch = FetchType.EAGER)
    public Holder getHolder() {
        return holder;
    }

    /**
     * @param holder the holder to set
     */
    public void setHolder(Holder holder) {
        this.holder = holder;
    }
    
    /**
     * @return the listOfNames
     */
    @OneToMany(fetch = FetchType.EAGER)
    public List<AttributeName> getListOfNames() {
        return listOfNames;
    }

    /**
     * @param listOfNames the listOfNames to set
     */
    public void setListOfNames(List<AttributeName> listOfNames) {
        this.listOfNames = listOfNames;
    }
    
    /**
     * @param newName
     */
    public void addName(AttributeName newName) {
        listOfNames.add(newName);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("<holder");
        if(getId() > 0) {
            buf.append(" id=\"").append(getId()).append("\"");
        }
        buf.append(">");
        buf.append(name);
        if(!listOfNames.isEmpty()) {
            buf.append("<list>");
            for(AttributeName attrName : listOfNames) {
                buf.append(attrName);
            }
            buf.append("</list>");
        }
        if(holder != null) {
            buf.append(holder);
        }
        buf.append("</holder>");
        return buf.toString();
    }

    
    
}
